Imports System.Text
Imports System.Threading.Tasks

Imports Microsoft.Azure.Devices
Imports Microsoft.Azure.Devices.Common.Exceptions
Imports System.Console

Namespace BrainComputerInterface_CreateIdentity
	Friend Class Program
		Private Shared _registryManager As RegistryManager
		Private Shared _connectionString As String = "HostName=****.azure-devices.net;SharedAccessKeyName=iothubowner;SharedAccessKey=***ADD YOURS HERE****"

		Shared Sub Main(ByVal args() As String)
			_registryManager = RegistryManager.CreateFromConnectionString(_connectionString)
			AddDeviceAsync.Wait()
			ReadLine()
		End Sub

		Private Shared async Function AddDeviceAsync() As Task
			Dim deviceId As String = "BrainComputerInterface001"
            Dim device As Device = New Device
            Dim result As Boolean
            Try
                device = Await _registryManager.AddDeviceAsync(New Device(deviceId))
            Catch e1 As DeviceAlreadyExistsException
                result = True
            End Try
            If (result = True) Then
                device = Await _registryManager.GetDeviceAsync(deviceId)
            End If
            WriteLine($"Generated device key: {device.Authentication.SymmetricKey.PrimaryKey}")
		End Function
	End Class
End Namespace
